/*  ------------------------------------------------------------------------
    discretize4crf: a supervised method to discretize continuous attributes
    ------------------------------------------------------------------------
 
    Copyright (C) 2010 Christian RAYMOND
 
    ..................................................................
 
    This file is part of discretize4crf
 
    discretize4crf is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    discretize4crf is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with discretize4crf.  If not, see <http://www.gnu.org/licenses/>.

    ..................................................................
                               
    Contact :
              Christian RAYMOND - INSA de Rennes - IRISA
              20 avenue des buttes de Cosme, Rennes, FRANCE
              christian.raymond@irisa.fr
    ..................................................................*/
	
	
#ifndef BASICOP_H
#define BASICOP_H
#include "constant.h"

void ERREUR(char *info,char *p);
float max(float a,float b);
int compareint (const void * a, const void * b);
int compare_cn(const void * a, const void * b);
int comparef (void const *a, void const *b);
int comparefb(const void * a, const void * b);
void affiche(MATRICE *m);
int ecrit_matrice(MATRICE *m,char *fichier);
void alloue_tab(TAB* t,long taille);
void alloue_col(COLONNE_NUMERIQUE* t,long taille,LABEL *l);
void desalloue_col(COLONNE_NUMERIQUE* t);
void desalloue_tab(TAB* t);
void alloue_tabf(TABF* t,long taille);
void desalloue_tabf(TABF* t);
void affiche_tabf(TABF* t,int nbline);
void affiche_tab(MATRICE* m,int colonne,TAB* t,int nbline);
void matrice_free(MATRICE* m);
char* long2readable(long size);
#endif
