/*  ------------------------------------------------------------------------
    discretize4crf: a supervised method to discretize continuous attributes
    ------------------------------------------------------------------------
 
    Copyright (C) 2010 Christian RAYMOND
 
    ..................................................................
 
    This file is part of discretize4crf
 
    discretize4crf is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    discretize4crf is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with discretize4crf.  If not, see <http://www.gnu.org/licenses/>.

    ..................................................................
                               
    Contact :
              Christian RAYMOND - INSA de Rennes - IRISA
              20 avenue des buttes de Cosme, Rennes, FRANCE
              christian.raymond@irisa.fr
    ..................................................................*/
	
	
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#include "discretize.h"
#include "label.h"


char* discretize(MATRICE *m,int colonne,int ligne,char inter[][INTERPRETATION],LABEL *stats)
{
	
	int j,miniclasse=0;
	char classe[100]="\0";
	char interpretation[INTERPRETATION]="\0";
	char tmp[100];
	char *value=(char *)malloc(5*sizeof(char));
	float v;
	
	
	sscanf(m->matrice[colonne][ligne],"%f",&v);
	free(m->matrice[colonne][ligne]);
	for(j=0;j<m->reponse[colonne]->nb_lignes;j++)
	{
		sprintf(tmp,"%f",m->reponse[colonne]->lignes[j]);
		while(tmp[strlen(tmp)-1]=='0') tmp[strlen(tmp)-1]='\0'; 
		if(v > m->reponse[colonne]->lignes[j]){strcat(classe,"1"); strcat(interpretation,">");}else{strcat(classe,"0"); strcat(interpretation,"<");}
		strcat(interpretation,tmp);
		strcat(interpretation," ");			
	}
	miniclasse=Linsert(&m->classes[colonne],classe);
	Linsert(&stats[miniclasse],m->matrice[m->nb_colonnes-1][ligne]);/*pour connaitre la repartition des labels dans la classe discrete*/
	
	strcpy(inter[miniclasse],interpretation);
	sprintf(tmp,"%d",miniclasse);
	strcpy(value,tmp);
	
	return value;
}



char* discretize_test(MATRICE *m,MATRICE *mt,int colonne,int ligne,LABEL *stats)
{
	
	int j,miniclasse=0;
	char classe[100]="\0";
	char tmp[100];
	char *value=(char *)malloc(5*sizeof(char));
	float v;
	if(value==NULL) {fprintf(stderr,"Can't allocate memory\n");exit(-1);}
	sscanf(mt->matrice[colonne][ligne],"%f",&v);
	for(j=0;j<m->reponse[colonne]->nb_lignes;j++)
	{
		sprintf(tmp,"%f",m->reponse[colonne]->lignes[j]);
		if(v > m->reponse[colonne]->lignes[j]){strcat(classe,"1"); }else{strcat(classe,"0");}
			
	}
	miniclasse=Linsert(&mt->classes[colonne],classe);
	/*fprintf(stderr,"tutu 4 mini=%d col:%d lign:%d\n",miniclasse,mt->nb_colonnes-1,ligne);*/
	Linsert(&stats[miniclasse],mt->matrice[mt->nb_colonnes-1][ligne]);/*pour connaitre la repartition des labels dans la classe discrete*/
	sprintf(tmp,"%d",miniclasse);
	strcpy(value,tmp);
	return value;
}


void simplifie(char *chaine)
{
	char result[INTERPRETATION],token1[100],token2[100],reste[INTERPRETATION],tmp[INTERPRETATION];
	float a,b;
	int test;
	strcpy(tmp,chaine);
	strcpy(result,"");
	while((test=sscanf(tmp,"%s %s %[ 0-9.,-><]",token1,token2,reste))>1)
	{
		/*fprintf(stderr,"tmp=%s 1=%s 2=%s reste=%s, (r=%s)\n",tmp,token1,token2,reste,result);*/
		if(sscanf(token1,">%f",&a) && sscanf(token2,">%f",&b))
		{
			if(a<b)
				strcpy(tmp,token2);
			else
				strcpy(tmp,token1);
			strcat(tmp," ");
			strcat(tmp,reste);
		}
		else
		{
			if(sscanf(token1,"<%f",&a) && sscanf(token2,"<%f",&b))
			{
				if(a>b)
					strcpy(tmp,token2);
				else
					strcpy(tmp,token1);
				strcat(tmp," ");
				strcat(tmp,reste);
			}
			else
			{
				if(reste[0] == token1[0])
				{
					strcpy(tmp,token1);
					strcat(tmp," ");
					strcat(tmp,reste);
					strcat(tmp," ");
					strcat(tmp,token2);
				}
				else
				{
					strcpy(tmp,token2);
					strcat(tmp," ");
					strcat(tmp,reste);
					strcat(tmp," ");
					strcat(tmp,token1);
				}
				if(test==2 && token1[0]!=token2[0])
				{
					
					if(token1[0]=='>')
					{
						token1[0]='[';
						token2[0]=',';
						strcat(token2,"]");
						strcpy(tmp,token1);
						strcat(tmp,token2);
					}
					else
					{
						token2[0]='[';
						token1[0]=',';
						strcat(token1,"]");
						strcpy(tmp,token2);
						strcat(tmp,token1);
					}
					break;
				}
			}
		}
		
		strcpy(reste,"");
		strcpy(token1,"");
		strcpy(token2,"");
	}
	strcpy(chaine,tmp);
}

