/*  ------------------------------------------------------------------------
    discretize4crf: a supervised method to discretize continuous attributes
    ------------------------------------------------------------------------
 
    Copyright (C) 2010 Christian RAYMOND
 
    ..................................................................
 
    This file is part of discretize4crf
 
    discretize4crf is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    discretize4crf is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with discretize4crf.  If not, see <http://www.gnu.org/licenses/>.

    ..................................................................
                               
    Contact :
              Christian RAYMOND - INSA de Rennes - IRISA
              20 avenue des buttes de Cosme, Rennes, FRANCE
              christian.raymond@irisa.fr
    ..................................................................*/
	
	
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "question.h"
#include "label.h"

float question(MATRICE* m,PARTITION *partition,int colonne,float q,int *split)
{
	int i;
	/*float test;*/
	LABEL p1,p2,p;
	float e1=0,e2=0,e=0,delta,gain;
	init_label(m,&p);
	init_label(m,&p1);
	init_label(m,&p2);

    for(i=partition->debut;q>m->resume[colonne].colonne[i].valeurs && i<partition->fin;i++)
	{
			add_label2label(&p1,&(m->resume[colonne].colonne[i].labels));

	    	add_label2label(&p,&(m->resume[colonne].colonne[i].labels));
    }
   	*split=i;
    while(i<partition->fin)
	{
            add_label2label(&p2,&(m->resume[colonne].colonne[i].labels));
			add_label2label(&p,&(m->resume[colonne].colonne[i].labels));
			i++;
    }
    
	for(i=0;i<p.nb_labels;i++)
		if(p.cpt[i]!=0) e+=-1*((float)p.cpt[i]/p.total)*log2((float)p.cpt[i]/p.total);
	for(i=0;i<p1.nb_labels;i++)
		if(p1.cpt[i]!=0) e1+=-1*((float)p1.cpt[i]/(p1.total)*log2((float)p1.cpt[i]/p1.total));
	for(i=0;i<p2.nb_labels;i++)
		if(p2.cpt[i]!=0) e2+=-1*((float)p2.cpt[i]/(p2.total)*log2((float)p2.cpt[i]/p2.total));
	
	delta=log2((float)p.total-1)/(float)p.total + (log2(pow(3,p.nb_labels))-((float)p.nb_labels*e-(float)p1.nb_labels*e1-(float)p2.nb_labels*e2))/(float)p.total;
	gain=e-(e1*((float)p1.total/(float)p.total)+(e2*(float)p2.total/(float)p.total));
	/*fprintf(stderr,"gain=%f delta=%f nb_label=%d,%d,%d\n",gain,delta,p.nb_labels,p1.nb_labels,p2.nb_labels);*/
	if(gain>delta) return gain;
	return gain-delta;
}
